.include "$lib/core.asm"
.include "$lib/std.asm"
.include "$lib/main.asm"

.define MEM_LOOP_I, CORE_MEM_MEM
.define MEM_LOOP_J, (MEM_LOOP_I + 1)
.define MEM_CALL_STACK_PTR, (MEM_LOOP_J + 1)
.define MEM_ALLOC_PTR, (MEM_CALL_STACK_PTR + 16)

.macro stack_transfer_alu
  .std_ld
  tlr CORE_REG_B
  .std_ld
  tlr CORE_REG_A
.endmacro

.macro call_stack_jump, call_stack_jump_arg_0_label
  .define call_stack_jump_local_offset, OFFSET
  .std_rset CORE_REG_C, call_stack_jump_arg_0_label
  .std_rset CORE_REG_D, (call_stack_jump_local_offset + 7)
  ts call_stack_jump
  tlr CORE_REG_PC
.endmacro

.macro return_call_stack_jump
  .std_jump return_call_stack_jump
.endmacro

.std_rset CORE_REG_A, MEM_CALL_STACK_PTR
.std_set MEM_CALL_STACK_PTR

.std_rset CORE_REG_A, (MEM_ALLOC_PTR + 1)
.std_set MEM_ALLOC_PTR

.jump_main

call_stack_jump:
  .std_get MEM_CALL_STACK_PTR
  tlr CORE_REG_A
  .std_rset CORE_REG_B, 1
  .std_alu CORE_ALU_ADD
  tlr CORE_REG_A
  tlr CORE_REG_B
  .std_set MEM_CALL_STACK_PTR

  tsr CORE_REG_D
  tlr CORE_REG_A
  tsr CORE_REG_B
  set
  tsr CORE_REG_C
  tlr CORE_REG_PC

return_call_stack_jump:
  .std_get MEM_CALL_STACK_PTR
  tlr CORE_REG_A
  tlr CORE_REG_C
  .std_rset CORE_REG_B, 1
  .std_alu CORE_ALU_SUB
  tlr CORE_REG_A
  .std_set MEM_CALL_STACK_PTR

  tsr CORE_REG_C
  get
  tlr CORE_REG_PC

